//
//  TRController.m
//  Tryst
//
//  Created by Francisco Tolmasky on Thu Apr 08 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "NSFileManager+TRAdditions.h"
#import "TRMovie.h"

#import "TRBroadcasting.h"

#import "TRWindowController.h"
#import "TRController.h"


@implementation TRController

- (id)init
{
    self= [super init];
    if(self)
    {
		library= [[NSKeyedUnarchiver unarchiveObjectWithFile: [[[[NSFileManager safeSupportFolder] path] stringByAppendingString: @"/Tryst Movie Library"] stringByExpandingTildeInPath]] retain];
		if(!library) library= [[NSMutableArray alloc] init];
		
		server= [[TRBroadcastServer alloc] init];
		client= [[TRBroadcastClient alloc] init];
		
        windowController= [[TRWindowController alloc] initWithController: self];
		
		signal(SIGPIPE, SIG_IGN);
    }
    return self;
}

- (void)dealloc
{
	[server release];
	[client release];
}

- (NSMutableArray *)library
{
	return library;
}

- (TRBroadcastServer *)server
{
	return server;
}

- (TRBroadcastClient *)client
{
	return client;
}

- (void)removeLostMovie:(TRMovie *)aMovie
{
	[[client movies] removeObject: aMovie];
	
	[[NSNotificationCenter defaultCenter]
		postNotification: TRBroadcastClientInformationDidChangeNotification
		object: self];
	
}

@end

@implementation TRController (NSApplicationDelegate)

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    [windowController window];//load window.
    [windowController showWindow: self];
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	[client close];
	[server stop];

	[NSKeyedArchiver archiveRootObject: library toFile: [[[[NSFileManager safeSupportFolder] path] stringByAppendingString: @"/Tryst Movie Library"] stringByExpandingTildeInPath]];

    [windowController applicationWillTerminate: aNotification];
}

- (void)workspaceWillPowerOff:(NSNotification *)aNotification
{
	[client close];
	[server stop];

	[NSKeyedArchiver archiveRootObject: library toFile: [[[[NSFileManager safeSupportFolder] path] stringByAppendingString: @"/Tryst Movie Library"] stringByExpandingTildeInPath]];

	[windowController applicationWillTerminate: aNotification];
}

@end