//
//  TRMovieGutterView.h
//  Tryst
//
//  Created by Francisco Tolmasky on Mon Feb 02 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>

@class TRMovieInspector;

typedef enum _TRMultiValuePosition
{
    TRInitialValuePosition=         0x001,
    TRIntermediateValuePosition=    0x000,
    TRFinalValuePosition=           0x010
} TRMultiValuePosition;

@interface TRMovieValueControl: NSMatrix
{
    NSString                *property;
    NSString                *identifier;
    NSString				*value;
	
    TRMultiValuePosition    position;
    
    TRMovieValueControl     *nextValueControl;
}

- (id)initWithProperty:(NSString *)aProperty
    identifier:(NSString *)anIdentifier
    position:(TRMultiValuePosition)aPosition;

- (void)setProperty:(NSString *)aProperty;
- (NSString *)property;

- (void)setIdentifier:(NSString *)anIdentifier;
- (NSString *)identifier;

- (void)setPosition:(TRMultiValuePosition)aPosition;
- (TRMultiValuePosition)position;

- (TRMovieValueControl *)nextValueControl;
- (void)setNextValueControl:(TRMovieValueControl *)aValueControl insert:(BOOL)insert;

@end

@interface TRMovieGutter : NSView
{
    TRMovieInspector        *movieInspector;
    
    struct
    {
        TRMovieValueControl *first;
        TRMovieValueControl *last;
        TRMovieValueControl *active;
    }                       valueControls;
}

- (void)setMovieInspector:(TRMovieInspector *)aMovieInspector;
- (TRMovieInspector *)movieInspector;

- (void)loadValueControls;

- (void)updateValueControlForProperty:(NSString *)aProperty identifier:(NSString *)anIdentifier withValue:(NSString *)aValue height:(float)aHeight;
- (void)updateActiveValueControlWithValue:(NSString *)aStringValue height:(float)aHeight;

@end
