//
//  TRTableView.m
//  Tryst
//
//  Created by Francisco Tolmasky on Wed Nov 26 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "TRMovieCell.h"
#import "TRMovieTableView.h"


@implementation TRMovieTableView

- (id)initWithCoder:(NSCoder *)aCoder
{
    self= [super initWithCoder: aCoder];
    if(self)
    {
        [[[self tableColumns] objectAtIndex: 0]
            setDataCell: [[TRMovieCell allocWithZone: [self zone]] init]];

		[self setVerticalMotionCanBeginDrag: NO];
		
		[self registerForDraggedTypes: [NSArray arrayWithObject: NSFilenamesPboardType]];
    }
    return self;
}

- (void)awakeFromNib
{
	[self setTarget: [[self window] windowController]];
	[self setDoubleAction: @selector(subscribe:)];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    //[super observeValueForKeyPath: keyPath ofObject: object change: change context: context];    [self setNeedsDisplay: YES];
}

- (void)mouseDown:(NSEvent *)theEvent
{
	[super mouseDown: theEvent];
	if(self==[[self window] firstResponder]) [movieListingController rearrangeObjects];
}

- (void)keyDown:(NSEvent *)theEvent
{
	[self interpretKeyEvents: [NSArray arrayWithObject: theEvent]]; 
}

- (void)deleteBackward:(id)sender
{
	[movieListingController remove: self];
}

- (NSDragOperation)draggingSourceOperationMaskForLocal:(BOOL)flag
{
	return NSDragOperationCopy;
}

@end