//
//  TRWindowController.h
//  Tryst
//
//  Created by Francisco Tolmasky on Tue Nov 18 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>


@class  TRController,
        TRMovieTableView,
        TRMovieInspector,
		TRMovieScrollView,
		TRIntegerControl,
		TRTimeIntervalControl,
        TRMovieListingController,
		TRBroadcastManager;
		
typedef enum
{
	TRWindowLibraryDisplayMode= 0,
	TRWindowBrowseDisplayMode=  1
} TRWindowDisplayMode;

@interface TRWindowController : NSWindowController
{
	TRWindowDisplayMode					displayMode;
	
    BOOL								isCollapsed;
    BOOL								collapseInProgress;
	
    float								movieListRowHeight;
    
	NSTimer								*movieListingTimer;
	
    //Model
	TRController						*controller;
    
    //Views
	IBOutlet NSTabView					*displayModeTabView;
	
	IBOutlet NSSearchField				*searchField;
	
    IBOutlet NSSplitView				*mainSplitView;
    IBOutlet NSView						*searchContainer;
	IBOutlet NSView						*controlsContainer;
	
	//IBOutlet NSView					*toolbarContainer;
	IBOutlet NSButton					*broadcastButton;
	IBOutlet NSButton					*subscribeButton;
	
    IBOutlet NSButton					*editButton;
    
    IBOutlet TRMovieTableView			*movieListing;
    IBOutlet TRMovieInspector			*movieInspector;
    IBOutlet TRMovieScrollView			*movieScrollView;
	
	IBOutlet NSSecureTextField			*passwordEntryTextField;
	IBOutlet NSPanel					*broadcastSheet;
	IBOutlet NSPanel					*passwordSheet;
    
	IBOutlet TRTimeIntervalControl		*timeRemainingControl;
	IBOutlet NSButton					*connectionLimitCheckBox;
	IBOutlet NSButton					*requirePasswordCheckBox;
	IBOutlet TRIntegerControl			*connectionLimitControl;
	IBOutlet NSSecureTextField			*passwordTextField;
	
    //Controllers
	IBOutlet TRMovieListingController   *movieListingController;
    IBOutlet NSObjectController			*inspectorController;
}

- (id)initWithController:(TRController *)aController;

- (void)setCollapsed:(BOOL)collapseFlag;
- (BOOL)collapsed;

- (void)setDisplayMode:(TRWindowDisplayMode)aDisplayMode;
- (TRWindowDisplayMode)displayMode;

// Movie Inspector

- (IBAction)toggleMovieInspector:(id)sender;

// Broadcast

- (IBAction)synchronizeBroadcastOptions:(id)sender;
- (IBAction)runBroadcastSheet:(id)sender;
- (IBAction)endBroadcastSheet:(id)sender;

- (IBAction)handleBroadcast:(id)sender;

- (IBAction)endPasswordSheet:(id)sender;

// Listening

- (IBAction)subscribe:(id)sender;

// Bug Reporting

- (IBAction)reportBug:(id)sender;

@end
