//
//  TRBugReport.m
//  Tryst
//
//  Created by Francisco Tolmasky on Sat Mar 20 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Message/NSMailDelivery.h>

#import "TRBugReport.h"


@implementation TRBugReport

+ (void)runBugReportForWindow:(NSWindow *)aWindow
{
	static TRBugReport *TRBugReporter= nil;
	if(!TRBugReporter) TRBugReporter= [[TRBugReport alloc] init];
	
	[NSApp
		beginSheet: TRBugReporter->panel
		modalForWindow: aWindow
		modalDelegate: TRBugReporter
		didEndSelector: @selector(sheetDidEnd:returnCode:contextInfo:)
		contextInfo: aWindow];
}

- (id)init
{
	self= [super init];
	if(self) [NSBundle loadNibNamed: @"TRBugReport" owner: self];
	return self;
}

- (void)deliverMessage:(NSAttributedString *)messageBody
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	NSMutableDictionary *headers= [NSMutableDictionary dictionary];
		
	[headers setObject: @"ftolmasky@adelphia.net" forKey: @"To"];
	[headers setObject: @"Tryst Interface Beta Bug Report" forKey: @"Subject"];
	[headers setObject: @"Apple Message" forKey: @"X-Mailer"];
	[headers setObject: @"multipart/mixed" forKey: @"Content-Type"];
	[headers setObject: @"1.0" forKey: @"Mime-Version"];
	
	[NSMailDelivery deliverMessage: messageBody
			headers: headers
			format: NSMIMEMailFormat
			protocol: nil];
	
	[messageBody release];
	
	[pool release];
}

- (void)sheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo
{
	if(returnCode)
	{
		NSMutableAttributedString *messageBody= [[NSMutableAttributedString alloc]
			initWithString: [NSString stringWithFormat: @"Problem Area: %@\nProblem Type: %@\n\n%@\n\n",
				[problemArea titleOfSelectedItem],
				[problemType titleOfSelectedItem],
				[problemDescription string]]];

		if([screenshotCheckBox state]==NSOnState)
		{
			NSRect compositeRect= NSMakeRect(0.0,0.0,0.0,0.0);
			compositeRect.size= [(NSWindow *)contextInfo frame].size;
			
			NSFileWrapper *pdfFile= [[[NSFileWrapper alloc] initRegularFileWithContents:
				[(NSWindow *)contextInfo dataWithPDFInsideRect: compositeRect]] autorelease];
			
			[pdfFile setPreferredFilename: @"screenshot.pdf"];
			
			NSTextAttachment *fileAttatchment= [[[NSTextAttachment alloc] initWithFileWrapper: pdfFile] autorelease];
			
			[messageBody appendAttributedString: [NSAttributedString attributedStringWithAttachment: fileAttatchment]];
		}
		
		[NSThread detachNewThreadSelector: @selector(deliverMessage:) toTarget: self withObject: messageBody];
	}
	
	[problemDescription setString: @""];
	
	[problemArea selectItemAtIndex: 0];
	[problemType selectItemAtIndex: 0];
	
	[screenshotCheckBox setState: NSOffState];
	
	[panel orderOut: self];
}

- (IBAction)close:(id)sender
{
	[NSApp endSheet: panel returnCode: [sender tag]];
}

@end
