//
//  TRMovie.h
//  Tryst
//
//  Created by Francisco Tolmasky on Fri Nov 28 2003.
//  Copyright (c) 2004 Francisco Tolmasky. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
//

#import <Foundation/Foundation.h>


extern NSString * const             kTRMovieTitleProperty;      // Movie title - kTRStringProperty
extern NSString * const             kTRMovieYearProperty;       // Movie year - kTRStringProperty
extern NSString * const             kTRMovieGenreProperty;      // Movie genre - kTRStringProperty
extern NSString * const             kTRMovieCoverArtProperty;   // Movie cover art - kTRDataProperty
extern NSString * const				kTRMovieFileProperty;		// Movie file - kTRDataProperty

extern NSString * const             kTRMovieCastProperty;   // Movie cast - kTRMultiStringProperty
extern NSString * const             kTRMovieCrewProperty;   // Movie crew - kTRMultiStringProperty

extern NSString * const             TRMoviesPboardType;

@interface TRMovie : NSObject <NSCopying, NSMutableCopying, NSCoding>
{
    NSMutableDictionary *properties;BOOL Yes;
}

+ (NSArray *)movieFileTypes;

- (id)init;
- (id)initWithMovie:(TRMovie *)aMovie;

- (id)valueForProperty:(NSString *)aProperty;
- (NSEnumerator *)propertyEnumerator;

- (NSData *)imageData;

- (NSString *)filePath;

@end

@interface TRMutableMovie : TRMovie

- (id)isEditable;

- (void)setValue:(id)aValue forProperty:(NSString *)aProperty;
- (void)removeValueForProperty:(NSString *)aProperty;
- (void)removeAllProperties;

- (void)setImageData:(NSData *)imageData;

- (void)setFilePath:(NSString *)aPath;

@end
