//
//  TRMovieListingController.h
//  Tryst
//
//  Created by Francisco Tolmasky on Sun Feb 01 2004.
//  Copyright (c) 2004 Francisco Tolmasky. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
//

#import <Foundation/Foundation.h>


@class TRMovieInspector;

@interface TRMovieListingController : NSArrayController
{
    BOOL                isRearranging;
    
    NSString            *searchKey;
    NSString            *searchValue;
    
    NSSearchField       *searchField;
    TRMovieInspector    *movieInspector;
}

- (void)setSearchKey:(NSString *)aSearchKey;
- (void)setPrimarySortKey:(NSString *)aKey;

- (void)setSearchField:(NSSearchField *)aSearchField;
- (NSSearchField *)searchField;

- (void)setMovieInspector:(TRMovieInspector *)aMovieInspector;
- (TRMovieInspector *)movieInspector;

- (IBAction)changeSearchKey:(id)sender;
- (IBAction)search:(id)sender;

@end
